// Package metadapt implements the Message and Transaction Demarcation Protocol.
package metadapt

// TODO: create interfaces for underlying connections for A and B, also have
// A and B fulfill hopp.Conn.

// A implements METADAPT-A over a singular stream-oriented transport such as TCP
// or UNIX domain stream sockets.
type A struct {
	// Underlying specifies the underlying connection. It must be set before
	// calling methods on this object.
	Underlying ATransport
}

// B implements METADAPT-B over a multiplexed stream-oriented transport such as
// QUIC.
type B struct {
	// Underlying specifies the underlying connection. It must be set before
	// calling methods on this object.
	Underlying BTransport
}
